<a id="types-aiobotocore-workdocs"></a>

# types-aiobotocore-workdocs

[![PyPI - types-aiobotocore-workdocs](https://img.shields.io/pypi/v/types-aiobotocore-workdocs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-workdocs)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-workdocs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-workdocs)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_workdocs/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-workdocs?color=blue)](https://pypistats.org/packages/types-aiobotocore-workdocs)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.WorkDocs 2.5.1](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/workdocs.html#WorkDocs)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-workdocs docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_workdocs/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-workdocs](#types-aiobotocore-workdocs)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `WorkDocs` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[workdocs]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[workdocs]'


# standalone installation
python -m pip install types-aiobotocore-workdocs
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-workdocs
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[workdocs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[workdocs]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[workdocs]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[workdocs]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[workdocs]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[workdocs]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[workdocs]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[workdocs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[workdocs]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[workdocs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[workdocs]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`WorkDocsClient` provides annotations for `session.create_client("workdocs")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_workdocs import WorkDocsClient

session = get_session()
async with session.create_client("workdocs") as client:
    client: WorkDocsClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_workdocs.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_workdocs import WorkDocsClient
from types_aiobotocore_workdocs.paginator import (
    DescribeActivitiesPaginator,
    DescribeCommentsPaginator,
    DescribeDocumentVersionsPaginator,
    DescribeFolderContentsPaginator,
    DescribeGroupsPaginator,
    DescribeNotificationSubscriptionsPaginator,
    DescribeResourcePermissionsPaginator,
    DescribeRootFoldersPaginator,
    DescribeUsersPaginator,
    SearchResourcesPaginator,
)

session = get_session()
async with session.create_client("workdocs") as client:
    client: WorkDocsClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    describe_activities_paginator: DescribeActivitiesPaginator = client.get_paginator(
        "describe_activities"
    )
    describe_comments_paginator: DescribeCommentsPaginator = client.get_paginator(
        "describe_comments"
    )
    describe_document_versions_paginator: DescribeDocumentVersionsPaginator = client.get_paginator(
        "describe_document_versions"
    )
    describe_folder_contents_paginator: DescribeFolderContentsPaginator = client.get_paginator(
        "describe_folder_contents"
    )
    describe_groups_paginator: DescribeGroupsPaginator = client.get_paginator("describe_groups")
    describe_notification_subscriptions_paginator: DescribeNotificationSubscriptionsPaginator = (
        client.get_paginator("describe_notification_subscriptions")
    )
    describe_resource_permissions_paginator: DescribeResourcePermissionsPaginator = (
        client.get_paginator("describe_resource_permissions")
    )
    describe_root_folders_paginator: DescribeRootFoldersPaginator = client.get_paginator(
        "describe_root_folders"
    )
    describe_users_paginator: DescribeUsersPaginator = client.get_paginator("describe_users")
    search_resources_paginator: SearchResourcesPaginator = client.get_paginator("search_resources")
```

<a id="literals"></a>

### Literals

`types_aiobotocore_workdocs.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_workdocs.literals import (
    ActivityTypeType,
    AdditionalResponseFieldTypeType,
    BooleanEnumTypeType,
    CommentStatusTypeType,
    CommentVisibilityTypeType,
    ContentCategoryTypeType,
    DescribeActivitiesPaginatorName,
    DescribeCommentsPaginatorName,
    DescribeDocumentVersionsPaginatorName,
    DescribeFolderContentsPaginatorName,
    DescribeGroupsPaginatorName,
    DescribeNotificationSubscriptionsPaginatorName,
    DescribeResourcePermissionsPaginatorName,
    DescribeRootFoldersPaginatorName,
    DescribeUsersPaginatorName,
    DocumentSourceTypeType,
    DocumentStatusTypeType,
    DocumentThumbnailTypeType,
    DocumentVersionStatusType,
    FolderContentTypeType,
    LanguageCodeTypeType,
    LocaleTypeType,
    OrderByFieldTypeType,
    OrderTypeType,
    PrincipalRoleTypeType,
    PrincipalTypeType,
    ResourceCollectionTypeType,
    ResourceSortTypeType,
    ResourceStateTypeType,
    ResourceTypeType,
    ResponseItemTypeType,
    RolePermissionTypeType,
    RoleTypeType,
    SearchCollectionTypeType,
    SearchQueryScopeTypeType,
    SearchResourceTypeType,
    SearchResourcesPaginatorName,
    ShareStatusTypeType,
    SortOrderType,
    StorageTypeType,
    SubscriptionProtocolTypeType,
    SubscriptionTypeType,
    UserFilterTypeType,
    UserSortTypeType,
    UserStatusTypeType,
    UserTypeType,
    WorkDocsServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: ActivityTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_workdocs.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_workdocs.type_defs import (
    AbortDocumentVersionUploadRequestRequestTypeDef,
    ActivateUserRequestRequestTypeDef,
    UserMetadataTypeDef,
    NotificationOptionsTypeDef,
    SharePrincipalTypeDef,
    ShareResultTypeDef,
    CreateCommentRequestRequestTypeDef,
    CreateCustomMetadataRequestRequestTypeDef,
    CreateFolderRequestRequestTypeDef,
    FolderMetadataTypeDef,
    CreateLabelsRequestRequestTypeDef,
    CreateNotificationSubscriptionRequestRequestTypeDef,
    SubscriptionTypeDef,
    StorageRuleTypeTypeDef,
    DateRangeTypeTypeDef,
    DeactivateUserRequestRequestTypeDef,
    DeleteCommentRequestRequestTypeDef,
    DeleteCustomMetadataRequestRequestTypeDef,
    DeleteDocumentRequestRequestTypeDef,
    DeleteDocumentVersionRequestRequestTypeDef,
    DeleteFolderContentsRequestRequestTypeDef,
    DeleteFolderRequestRequestTypeDef,
    DeleteLabelsRequestRequestTypeDef,
    DeleteNotificationSubscriptionRequestRequestTypeDef,
    DeleteUserRequestRequestTypeDef,
    DescribeActivitiesRequestDescribeActivitiesPaginateTypeDef,
    DescribeActivitiesRequestRequestTypeDef,
    DescribeCommentsRequestDescribeCommentsPaginateTypeDef,
    DescribeCommentsRequestRequestTypeDef,
    DescribeDocumentVersionsRequestDescribeDocumentVersionsPaginateTypeDef,
    DescribeDocumentVersionsRequestRequestTypeDef,
    DocumentVersionMetadataTypeDef,
    DescribeFolderContentsRequestDescribeFolderContentsPaginateTypeDef,
    DescribeFolderContentsRequestRequestTypeDef,
    DescribeGroupsRequestDescribeGroupsPaginateTypeDef,
    DescribeGroupsRequestRequestTypeDef,
    GroupMetadataTypeDef,
    DescribeNotificationSubscriptionsRequestDescribeNotificationSubscriptionsPaginateTypeDef,
    DescribeNotificationSubscriptionsRequestRequestTypeDef,
    DescribeResourcePermissionsRequestDescribeResourcePermissionsPaginateTypeDef,
    DescribeResourcePermissionsRequestRequestTypeDef,
    DescribeRootFoldersRequestDescribeRootFoldersPaginateTypeDef,
    DescribeRootFoldersRequestRequestTypeDef,
    DescribeUsersRequestDescribeUsersPaginateTypeDef,
    DescribeUsersRequestRequestTypeDef,
    EmptyResponseMetadataTypeDef,
    LongRangeTypeTypeDef,
    SearchPrincipalTypeTypeDef,
    GetCurrentUserRequestRequestTypeDef,
    GetDocumentPathRequestRequestTypeDef,
    GetDocumentRequestRequestTypeDef,
    GetDocumentVersionRequestRequestTypeDef,
    GetFolderPathRequestRequestTypeDef,
    GetFolderRequestRequestTypeDef,
    GetResourcesRequestRequestTypeDef,
    InitiateDocumentVersionUploadRequestRequestTypeDef,
    UploadMetadataTypeDef,
    PaginatorConfigTypeDef,
    PermissionInfoTypeDef,
    RemoveAllResourcePermissionsRequestRequestTypeDef,
    RemoveResourcePermissionRequestRequestTypeDef,
    ResourcePathComponentTypeDef,
    ResponseMetadataTypeDef,
    RestoreDocumentVersionsRequestRequestTypeDef,
    SearchSortResultTypeDef,
    UpdateDocumentRequestRequestTypeDef,
    UpdateDocumentVersionRequestRequestTypeDef,
    UpdateFolderRequestRequestTypeDef,
    ResourceMetadataTypeDef,
    AddResourcePermissionsRequestRequestTypeDef,
    AddResourcePermissionsResponseTypeDef,
    CreateFolderResponseTypeDef,
    DescribeRootFoldersResponseTypeDef,
    GetFolderResponseTypeDef,
    CreateNotificationSubscriptionResponseTypeDef,
    DescribeNotificationSubscriptionsResponseTypeDef,
    CreateUserRequestRequestTypeDef,
    UpdateUserRequestRequestTypeDef,
    UserStorageMetadataTypeDef,
    DescribeDocumentVersionsResponseTypeDef,
    DocumentMetadataTypeDef,
    GetDocumentVersionResponseTypeDef,
    DescribeGroupsResponseTypeDef,
    ParticipantsTypeDef,
    FiltersTypeDef,
    PrincipalTypeDef,
    ResourcePathTypeDef,
    UserTypeDef,
    DescribeFolderContentsResponseTypeDef,
    GetDocumentResponseTypeDef,
    GetResourcesResponseTypeDef,
    InitiateDocumentVersionUploadResponseTypeDef,
    SearchResourcesRequestRequestTypeDef,
    SearchResourcesRequestSearchResourcesPaginateTypeDef,
    DescribeResourcePermissionsResponseTypeDef,
    GetDocumentPathResponseTypeDef,
    GetFolderPathResponseTypeDef,
    ActivateUserResponseTypeDef,
    CommentMetadataTypeDef,
    CommentTypeDef,
    CreateUserResponseTypeDef,
    DescribeUsersResponseTypeDef,
    GetCurrentUserResponseTypeDef,
    UpdateUserResponseTypeDef,
    ActivityTypeDef,
    ResponseItemTypeDef,
    CreateCommentResponseTypeDef,
    DescribeCommentsResponseTypeDef,
    DescribeActivitiesResponseTypeDef,
    SearchResourcesResponseTypeDef,
)


def get_structure() -> AbortDocumentVersionUploadRequestRequestTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-workdocs` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_workdocs/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
